# WOK
TKWOK
WOKernel

# WOKernel_Entity Class Reference

Base class of WOK entities (Factories, Warehouses,
Workshops, Workbenches, Development units.)
.

`#include <WOKernel_Entity.hxx>`

Inheritance diagram for WOKernel_Entity:

[legend]

## Public Member Functions

virtual Standard_EXPORT Handle_TCollection_HAsciiString | EntityCode () const =0
Standard_EXPORT void | GetParams ()
Standard_EXPORT void | SetParams (const WOKUtils_Param &aparam)
| change Parameters of Entity
WOKUtils_Param & | ChangeParams ()
| Get parameters of Entity .
const WOKUtils_Param & | Params () const
| Get parameters of Entity .
Standard_EXPORT Handle_TCollection_HAsciiString | ParameterName (const Standard_CString aname) const
Standard_EXPORT Handle_TCollection_HAsciiString | EvalParameter (const Standard_CString aparamname, const Standard_Boolean isnecessary=Standard_True) const
| Evaluates a parameter for the entity Name_<aparamname> is evaluated .
Standard_EXPORT Handle_TCollection_HAsciiString | EvalDefaultParameterValue (const Handle(TCollection_HAsciiString)&aparamname, const Standard_Integer evaldepth=0)
| Looks up for a default value to Parameter <aparamname> //! Sets profile parameters Station = ao1|sun|hp|sil DBMS = MEM|OBJY|OBJS|OO2 Nesting_Station = Nesting_%Station Nesting_DBMS = Nesting_%DBMS .
Standard_EXPORT Handle_WOKernel_FileTypeBase | FileTypeBase () const
Standard_EXPORT Handle_WOKernel_FileType | GetFileType (const Handle(TCollection_HAsciiString)&atypename) const
Standard_EXPORT Handle_WOKernel_FileType | GetFileType (const Standard_CString atypename) const
Standard_EXPORT void | DumpBuildParameters (const Handle(WOKUtils_HSequenceOfParamItem)&aparamseq) const
| Dumps in a file the construction parameters of Entity .
virtual Standard_EXPORT Handle_WOKUtils_HSequenceOfParamItem | BuildParameters (const Handle(WOKUtils_HSequenceOfParamItem)&someparams, const Standard_Boolean usedefaults)
| constructs Sequence of Parameters Needed by Entity to be built. Checks their consistancy
virtual Standard_EXPORT Standard_Boolean | IsValidName () const
| Checks if name given to the entity is valid (forbidden characters are : " /<>}*~" .
virtual Standard_EXPORT void | Build (const Handle(WOKUtils_HSequenceOfParamItem)&someparams)
| Creates On disk the Entity it must neither be opened or existing Parameters must all be present in someparams .
virtual Standard_EXPORT void | Destroy ()
| Destroys Entity on Disk it must not be opened .
virtual Standard_EXPORT void | Open ()=0
| open an existing entity
Standard_EXPORT void | SetOpened ()
| Flag Entity as Opened .
virtual Standard_EXPORT void | Reset ()
| resets Entity fields (eq:Close)
virtual Standard_EXPORT void | Close ()=0
| closes entity
Standard_EXPORT void | SetClosed ()
| flag entity as closed
Standard_Boolean | IsOpened () const
| tests if Entity is opened
virtual Standard_EXPORT Handle_TCollection_HAsciiString | GetUniqueName () const
| Calcultes the unique name of base entity .
Standard_EXPORT Handle_TCollection_HAsciiString | NestedUniqueName (const Handle(TCollection_HAsciiString)&aname) const
| Calculates the unique name of an Entity Nested in Entity .
Standard_EXPORT Handle_WOKernel_HSequenceOfStationID | Stations () const
Standard_EXPORT Handle_WOKernel_HSequenceOfDBMSID | DBMSystems () const
Standard_EXPORT void | Kill ()
| Destroys The Entity .
| ~WOKernel_Entity ()
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Static Public Member Functions

static Standard_EXPORT Standard_Boolean | IsValidName (const Handle(TCollection_HAsciiString)&aname)
| Checks if name given to the entity is valid (forbidden characters are : " /<>}*~_" .

## Protected Member Functions

Standard_EXPORT | WOKernel_Entity (const Handle(TCollection_HAsciiString)&aname, const Handle(WOKernel_Entity)&anesting)
| Initialize a WOKernel Entity .
virtual Standard_EXPORT void | GetParameters ()
Standard_EXPORT void | SetFileTypeBase (const Handle(WOKernel_FileTypeBase)&abase)

## Private Attributes

WOKUtils_Param | myparams
Handle_WOKernel_FileTypeBase | mytypes
Standard_Boolean | myopenstatus
Handle_WOKernel_HSequenceOfStationID | mystations
Handle_WOKernel_HSequenceOfDBMSID | mydbmss

## Constructor & Destructor Documentation

WOKernel_Entity::~WOKernel_Entity | ( |  | ) | `[inline]`

Standard_EXPORT WOKernel_Entity::WOKernel_Entity | ( | const Handle(TCollection_HAsciiString)& | aname,
|  | const Handle(WOKernel_Entity)& | anesting
| ) | `[protected]`

## Member Function Documentation

virtual Standard_EXPORT void WOKernel_Entity::Build | ( | const Handle(WOKUtils_HSequenceOfParamItem)& | someparams | ) | `[virtual]`

| Reimplemented in WOKernel_DevUnit, and WOKernel_Session.

virtual Standard_EXPORT Handle_WOKUtils_HSequenceOfParamItem WOKernel_Entity::BuildParameters | ( | const Handle(WOKUtils_HSequenceOfParamItem)& | someparams,
|  | const Standard_Boolean | usedefaults
| ) | `[virtual]`

| Reimplemented in WOKernel_DevUnit, WOKernel_Session, and WOKernel_Workshop.

WOKUtils_Param & WOKernel_Entity::ChangeParams | ( |  | ) | `[inline]`

virtual Standard_EXPORT void WOKernel_Entity::Close | ( |  | ) | `[pure virtual]`

| Implemented in WOKernel_DevUnit, WOKernel_Factory, WOKernel_Parcel, WOKernel_Session, WOKernel_UnitNesting, WOKernel_Warehouse, WOKernel_Workbench, and WOKernel_Workshop.

Standard_EXPORT Handle_WOKernel_HSequenceOfDBMSID WOKernel_Entity::DBMSystems | ( |  | ) | const

virtual Standard_EXPORT void WOKernel_Entity::Destroy | ( |  | ) | `[virtual]`

| Reimplemented in WOKernel_DevUnit, and WOKernel_Session.

Standard_EXPORT void WOKernel_Entity::DumpBuildParameters | ( | const Handle(WOKUtils_HSequenceOfParamItem)& | aparamseq | ) | const

virtual Standard_EXPORT Handle_TCollection_HAsciiString WOKernel_Entity::EntityCode | ( |  | ) | const`[pure virtual]`

| Implemented in WOKernel_DevUnit, WOKernel_Factory, WOKernel_Parcel, WOKernel_Session, WOKernel_Warehouse, WOKernel_Workbench, and WOKernel_Workshop.

Standard_EXPORT Handle_TCollection_HAsciiString WOKernel_Entity::EvalDefaultParameterValue | ( | const Handle(TCollection_HAsciiString)& | aparamname,
|  | const Standard_Integer | evaldepth = `0`
| ) |

Standard_EXPORT Handle_TCollection_HAsciiString WOKernel_Entity::EvalParameter | ( | const Standard_CString | aparamname,
|  | const Standard_Boolean | isnecessary = `Standard_True`
| ) | const

Standard_EXPORT Handle_WOKernel_FileTypeBase WOKernel_Entity::FileTypeBase | ( |  | ) | const

Standard_EXPORT Handle_WOKernel_FileType WOKernel_Entity::GetFileType | ( | const Standard_CString | atypename | ) | const

Standard_EXPORT Handle_WOKernel_FileType WOKernel_Entity::GetFileType | ( | const Handle(TCollection_HAsciiString)& | atypename | ) | const

virtual Standard_EXPORT void WOKernel_Entity::GetParameters | ( |  | ) | `[protected, virtual]`

| Reimplemented in WOKernel_DevUnit, WOKernel_Workbench, and WOKernel_Workshop.

Standard_EXPORT void WOKernel_Entity::GetParams | ( |  | ) |

virtual Standard_EXPORT Handle_TCollection_HAsciiString WOKernel_Entity::GetUniqueName | ( |  | ) | const`[virtual]`

| Implements WOKernel_BaseEntity.

Standard_EXPORT const WOKernel_Entity::Handle | ( | Standard_Type |  | ) | const

| Reimplemented from WOKernel_BaseEntity. Reimplemented in WOKernel_DevUnit, WOKernel_Factory, WOKernel_Parcel, WOKernel_Session, WOKernel_UnitNesting, WOKernel_Warehouse, WOKernel_Workbench, and WOKernel_Workshop.

Standard_Boolean WOKernel_Entity::IsOpened | ( |  | ) | const`[inline]`

static Standard_EXPORT Standard_Boolean WOKernel_Entity::IsValidName | ( | const Handle(TCollection_HAsciiString)& | aname | ) | `[static]`

virtual Standard_EXPORT Standard_Boolean WOKernel_Entity::IsValidName | ( |  | ) | const`[virtual]`

Standard_EXPORT void WOKernel_Entity::Kill | ( |  | ) |

Standard_EXPORT Handle_TCollection_HAsciiString WOKernel_Entity::NestedUniqueName | ( | const Handle(TCollection_HAsciiString)& | aname | ) | const

virtual Standard_EXPORT void WOKernel_Entity::Open | ( |  | ) | `[pure virtual]`

| Implemented in WOKernel_DevUnit, WOKernel_Factory, WOKernel_Parcel, WOKernel_Session, WOKernel_UnitNesting, WOKernel_Warehouse, WOKernel_Workbench, and WOKernel_Workshop.

Standard_EXPORT Handle_TCollection_HAsciiString WOKernel_Entity::ParameterName | ( | const Standard_CString | aname | ) | const

const WOKUtils_Param & WOKernel_Entity::Params | ( |  | ) | const`[inline]`

virtual Standard_EXPORT void WOKernel_Entity::Reset | ( |  | ) | `[virtual]`

Standard_EXPORT void WOKernel_Entity::SetClosed | ( |  | ) |

Standard_EXPORT void WOKernel_Entity::SetFileTypeBase | ( | const Handle(WOKernel_FileTypeBase)& | abase | ) | `[protected]`

Standard_EXPORT void WOKernel_Entity::SetOpened | ( |  | ) |

Standard_EXPORT void WOKernel_Entity::SetParams | ( | const WOKUtils_Param & | aparam | ) |

Standard_EXPORT Handle_WOKernel_HSequenceOfStationID WOKernel_Entity::Stations | ( |  | ) | const

## Field Documentation

Handle_WOKernel_HSequenceOfDBMSID WOKernel_Entity::mydbmss `[private]`

Standard_Boolean WOKernel_Entity::myopenstatus `[private]`

WOKUtils_Param WOKernel_Entity::myparams `[private]`

Handle_WOKernel_HSequenceOfStationID WOKernel_Entity::mystations `[private]`

| Reimplemented in WOKernel_Workshop.

Handle_WOKernel_FileTypeBase WOKernel_Entity::mytypes `[private]`

The documentation for this class was generated from the following files:

- WOKernel_Entity.hxx
- WOKernel_Entity.lxx